<?php

/*
=====================================================
 DataLife Engine v11.2
-----------------------------------------------------
 Persian support site: http://datalifeengine.ir
-----------------------------------------------------
 Translate & Develope : Seyed Ehsan Setarehdan
 -----------------------------------------------------
 https://Asemane.ir
-----------------------------------------------------
 FileName : engine/classes/htmlpurifier/standalone/HTMLPurifier/ConfigSchema/Builder/ConfigSchema.php
-----------------------------------------------------
 Copyright (c) 2006-2017, All rights reserved.
=====================================================
*/
class HTMLPurifier_ConfigSchema_Builder_ConfigSchema
{

    /**
     * @param HTMLPurifier_ConfigSchema_Interchange $interchange
     * @return HTMLPurifier_ConfigSchema
     */
    public function build($interchange)
    {
        $schema = new HTMLPurifier_ConfigSchema();
        foreach ($interchange->directives as $d) {
            $schema->add(
                $d->id->key,
                $d->default,
                $d->type,
                $d->typeAllowsNull
            );
            if ($d->allowed !== null) {
                $schema->addAllowedValues(
                    $d->id->key,
                    $d->allowed
                );
            }
            foreach ($d->aliases as $alias) {
                $schema->addAlias(
                    $alias->key,
                    $d->id->key
                );
            }
            if ($d->valueAliases !== null) {
                $schema->addValueAliases(
                    $d->id->key,
                    $d->valueAliases
                );
            }
        }
        $schema->postProcess();
        return $schema;
    }
}

// vim: et sw=4 sts=4
